SystemOrganization addCategory: #'PBE-LightsOut'!

SimpleSwitchMorph subclass: #LOCell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOCell commentStamp: 'AamerCharania 1/17/2013 14:42' prior: 0!
Test comment

Unfortunately this class has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables. We encourage you to fill up the following template.

Class intention
	I m doing the following ...

Class collaborations
	I usually do not work in isolation but with the help of ...

Class main API
	My main public API is ...My subclasses may want to override such specific hooks ...
Implementation notes
!

!LOCell methodsFor: 'initialization' stamp: 'AamerCharania 1/17/2013 14:45'!
initialize
super initialize.
self label: ''.
self borderWidth: 2.
bounds := 0@0 corner: 16@16.
offColor := Color paleYellow.
onColor := Color paleBlue darker.
self useSquareCorners.
self turnOff! !

!LOCell methodsFor: 'as yet unclassified' stamp: 'AamerCharania 1/17/2013 16:33'!
mouseAction
^ mouseAction! !

!LOCell methodsFor: 'as yet unclassified' stamp: 'AamerCharania 1/17/2013 16:31'!
mouseAction: aBlock
^ mouseAction := aBlock! !

!LOCell methodsFor: 'event handling' stamp: 'AamerCharania 1/17/2013 16:34'!
mouseUp: anEvent
mouseAction value! !

BorderedMorph subclass: #LOGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOGame commentStamp: 'AamerCharania 1/17/2013 16:09' prior: 0!
test comments
Unfortunately this class has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables. We encourage you to fill up the following template.

Class intention
	I m doing the following ...

Class collaborations
	I usually do not work in isolation but with the help of ...

Class main API
	My main public API is ...My subclasses may want to override such specific hooks ...
Implementation notes
!

!LOGame methodsFor: 'initialization' stamp: 'AamerCharania 1/17/2013 16:26'!
cellsPerSide
"The number of cells along each side of the game"
^ 10! !

!LOGame methodsFor: 'initialization' stamp: 'AamerCharania 1/17/2013 16:13'!
initialize
| sampleCell width height n |
super initialize.
n := self cellsPerSide.
sampleCell := LOCell new.
width := sampleCell width.
height := sampleCell height.
self bounds: (5@5 extent: ((width*n) @(height*n)) + (2 * self borderWidth)).
cells := Matrix new: n tabulate: [ :i :j | self newCellAt: i at: j ].! !

!LOGame methodsFor: 'event handling' stamp: 'AamerCharania 1/17/2013 16:53'!
mouseMove: anEvent! !

!LOGame methodsFor: 'initialization' stamp: 'AamerCharania 1/17/2013 16:47'!
newCellAt: i at: j
"Create a cell for position (i,j) and add it to my on-screen representation at the appropriate screen position.  Answer the new cell"
| c origin |
c := LOCell new.
origin := self innerBounds origin.
self addMorph: c.
c position: ((i - 1) * c width) @ ((j - 1) * c height) + origin.
c mouseAction: [self toggleNeighboursOfCellAt: i at: j].
^ c! !

!LOGame methodsFor: 'game logic' stamp: 'AamerCharania 1/17/2013 16:29'!
toggleNeighboursOfCellAt: i at: j
(i > 1) ifTrue: [ (cells at: i - 1 at: j ) toggleState].
(i < self cellsPerSide) ifTrue: [ (cells at: i + 1 at: j) toggleState].
(j > 1) ifTrue: [ (cells at: i at: j - 1) toggleState].
(j < self cellsPerSide) ifTrue: [ (cells at: i at: j + 1) toggleState].! !
